Subject: bug#828: [devuan-dev] bug#828: devuan-project: After an upgrade (apt update; apt full-upgrade) the PC fails to reboot correctly.

From: Lorenzo <[email-masked]>
Date: Fri, 5 Jan 2024 18:06:20 +0100

On Fri, 5 Jan 2024 14:28:26 +0100
David Haworth <[email-masked]> wrote:

> Hi Lorenzo,
> 
> On 2024-01-05 13:44:25 +0100, Lorenzo wrote:
> > I agree but split /usr without initrd is not supported (upstream)
> > since like a decade, it more or less worked until now but Debian is
> > finally breaking it for good with the usrmerge fallout. See my
> > reply in #827 https://bugs.devuan.org/cgi/bugreport.cgi?bug=827
> 
> Don't get me wrong - I don't have a split system like that.
> I was just wondering what a "correct" solution would look like.

I think the safest thing is to merge your system, by installing
the usrmerge package; it will move stuff for you and turn /bin
/sbin /lib into symlinks to their /usr/* conterparts.
(example /bin ---> /usr/bin)
This way you go to the layout that is officially supported
by Debian and all this trouble will disappear.

If for some reason, you don't want to do that, expect more
breakage in the incoming weeks. You can try to counter that
with symlinks or by extending the PATH var in scripts,
removing hardcoded paths and so but I'm not sure it will be
sustainable.
Note that while Debian decided to move binaries inside packages,
they decided to not break the amd64 ABI, so binaries can still
use /lib*/ld-linux-x86-64.so.2 as intepreter, and scripts will
keep using /bin/sh. I'm really not sure that will be possible
to create symlinks with 'ln' when /lib/ is empty.. prepare a
rescue system to repair the links, just in case.

Lorenzo

> Best wishes,
> Dave